#include <cstdlib>
#include "numbertheory.h"

// Greatest Common Divisor
template <class IT>
IT gcd(IT a, IT b) {

  a = abs(a);
  b = abs(b);

  if (a == 0)
    return b;
  if (b == 0)
    return a;

  do {
    IT t = a % b;
    a = b;
    b = t;
  } while (b != 0);

  return a;
}


// Least Common Multiple
template <class IT>
IT lcm(IT a, IT b) {

  if (a == 0 || b == 0)
    return 0;
  return a*(b/gcd<IT>(a,b));
}



int gcd(int a, int b) {
  return gcd<int>(a, b);
}

int lcm(int a, int b) {
  return lcm<int>(a, b);
}

int gcd(long a, int b) {
  return gcd<long>(a, b); 
}

long lcm(long a, int b) {
  return lcm<long>(a, b);
}

int gcd(int a, long b) {
  return gcd<long>(a, b); 
}

long lcm(int a, long b) {
  return lcm<long>(a, b);
}

long gcd(long a, long b) {
  return gcd<long>(a, b);
}

long lcm(long a, long b) {
  return lcm<long>(a, b);
}
