#include <cstdlib>
#include <cerrno>
#include "lfrng.h"

using namespace LFRNG;

rng::rng(unsigned n) {

    k = l_k;
    l = l_l;
    if (n <= s_k) {
        k = s_k;
        l = s_l;
    } else if (n <= m_k) {
        k = m_k;
        l = m_l;
    } else if (n > l_k)
        errno = EDOM;

    hstr = new unsigned[k];

    init();
}


rng::~rng() {
    delete[] hstr;
}


void rng::init() {
    int i;

    for(i=0; i<k; ++i)
        hstr[k-i-1] = rand();

    imk = k-1;
        iml = l-1;
}


unsigned rng::draw() {
    unsigned r;

    r = hstr[imk] + hstr[iml];
    hstr[imk] = r;
    if (imk-- == 0) imk = k-1;
    if (iml-- == 0) iml = k-1;

    return r;
}
