#include <cmath>
#include "frng.h"

using namespace FPRNG;

double ferng::operator() () {
    double r;
    while(0.0 == (r = frng::draw()));
    return -log(r);
}

double fnrng::operator() () {
    double x1, x2, r2, f;

    if (cached) {
        cached = false;
        return ndr;
    }

    do {
        x1 = frng::draw()*2.0 - 1.0;
        x2 = frng::draw()*2.0 - 1.0;
        r2 = x1*x1 + x2*x2;
    } while(r2 > 1.0 || 0.0 == r2);
    f = sqrt(-2.0*log(r2)/r2);
    ndr = x2*f;
    cached = true;
    return x1*f;
}
