#ifndef POSITION_H
#define POSITION_H

struct position {
    double x, y, z;
    
    position() {}
    position(double a, double b, double c) : x(a), y(b), z(c) {}
    
    position operator+() const { return *this; }
    position operator-() const { return position(-x, -y, -z); }
    
    position& operator+= (position r) { x += r.x; y += r.y; z += r.z; return *this; }
    position& operator-= (position r) { x -= r.x; y -= r.y; z -= r.z; return *this; }
    position& operator*= (double s) { x *= s; y *= s; z *= s; return *this; }
    position& operator/= (double s) { x /= s; y /= s; z /= s; return *this; }

    friend position operator+ (position r1, position r2);
    friend double operator* (position r1, position r2);

};

inline position operator+ (position r1, position r2) {
    r1 += r2;
    return r1;
}

inline double operator* (position r1, position r2) {
    return r1.x*r2.x + r1.y*r2.y + r1.z*r2.z;
}

#endif
