#ifndef VELOCITY_H
#define VELOCITY_H

#include "position.h"

struct velocity : public position {
protected:
    velocity(position r) : position(r) {}
public:
    velocity() {}
    velocity(double a, double b, double c) : position(a,b,c) {}
    
    velocity operator+() const { return *this; }
    velocity operator-() const { return this->position::operator-(); }

    velocity& operator+= (velocity v) { this->position::operator+=(v); return *this; }
    velocity& operator-= (velocity v) { this->position::operator-=(v); return *this; }
    velocity& operator*= (double s) { this->position::operator*=(s); return *this; }
    velocity& operator/= (double s) { this->position::operator/=(s); return *this; }

    velocity operator+ (velocity v) const { return this->position::operator+(v); }
    velocity operator- (velocity v) const { return this->position::operator-(v); }
    double operator* (velocity v) const { return this->position::operator*(v); }
    velocity operator* (double s) const { return this->position::operator*(s); }
    friend velocity operator* (double s, velocity v);
    velocity operator/ (double s) const { return this->position::operator/(s); }
    bool operator== (velocity v) const { return this->position::operator==(v); }
    bool operator!= (velocity v) const { return this->position::operator!=(v); }

    friend double abs(velocity v);
};

inline velocity operator* (double s, velocity v) {
    v *= s;
    return v;
}

inline double abs(velocity v) {
    return abs(position(v));
}

#endif
