#ifndef BINGO_H
#define BINGO_H

#include "lfrng.h"

namespace LFRNG {

class bingo : protected rng {
    static const unsigned numbers = 90U;

    unsigned m;
    unsigned cage[numbers];
    
    void initCage() {
        for(int i=0; i<numbers; i++) cage[i] = i+1;
    };
public:
    explicit bingo(unsigned n=98) : rng(n), m(numbers) {
            initCage();
        }
    bingo(unsigned n, const unsigned *a) : rng(n,a), m(numbers) {
            initCage();
        }

    unsigned drawn() const { return numbers-m; }

    unsigned left() const { return m; }

    bool empty() const { return m==0; }

    unsigned drawn(unsigned i) const {
        if (i > drawn())
            return 0;
        return cage[numbers-i];
    }

    unsigned operator() () {
         if (m) {
             unsigned i = rng::draw()%m;
             unsigned t = cage[i];
             cage[i] = cage[m-1];
             cage[m-1] = t;
             --m;
             return t;
         } else
             return 0;
    }
};

} // NAMESPACE LFRNG

#endif